#include <iostream>
#include <chrono>
#include <cstdlib>

using namespace std;
using namespace std::chrono;

void swap(int &a, int &b) {
    int temp = a;
    a = b;
    b = temp;
}

#define sort(arr, n, start_time)\
for (unsigned long i = 0; i < n - 1; i++) {\
        unsigned long minIndex = i;\
        for (unsigned long j = i + 1; j < n; j++) if (arr[j] < arr[minIndex]) minIndex = j;\
        if (minIndex != i) swap(arr[minIndex], arr[i]);\
        unsigned short progress = (i + 1) * 100 / (n - 1);\
        auto current_time = high_resolution_clock::now();\
        auto elapsed_time = duration_cast<seconds>(current_time - start_time);\
        if ((progress > (i) * 100 / (n - 1))||elapsed_time.count() >= 5 && !progress)cout << "Sorted " << progress << "% (" << i + 2 << " of " << n << " elements)" << endl;}

bool is_sorted(int arr[], unsigned long n) {
    for (unsigned long i = 0; i < n - 1; i++) {
        if (arr[i] > arr[i + 1]) {
            return false;
        }
    }
    return true;
}

int main() {
    cout << "How many ints?" << endl;
    unsigned long much;
    cin >> much;
    int* arr = new int[much];
    srand(time(0));
    for (unsigned long i = 0; i < much; i++) arr[i] = rand();
    std::chrono::high_resolution_clock::time_point start = high_resolution_clock::now();
    sort(arr, much, start);
    if (is_sorted(arr, much))cout << "Array is sorted correctly.";
    else                     cout << "Array is not sorted correctly.";
    cout << endl << "Time taken for sorting: " << duration_cast<microseconds>(high_resolution_clock::now() - start).count() << " microseconds." << endl;
    delete[] arr;
    return 0;
}
